; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include Select.inc        ; local includes for this file

      select_win PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      get_select_rect PROTO :DWORD,:DWORD
      PushButton PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      ButnProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
      hSelect dd ?
      lpButnProc dd ?

    .code

start:

; 

      invoke InitCommonControls

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"Prostart_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL tbh    :DWORD
    LOCAL wd     :DWORD
    LOCAL ht     :DWORD
    LOCAL Rct    :RECT
    LOCAL pt     :POINT
    LOCAL pbuf   :DWORD
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== toolbar commands ========
          Case 50
            fn MessageBox,hWin,"WM_COMMAND ID 50", \
                          ADDR szDisplayName,MB_OK
          Case 51
            fn MessageBox,hWin,"WM_COMMAND ID 51", \
                          ADDR szDisplayName,MB_OK
          Case 52
            fn MessageBox,hWin,"WM_COMMAND ID 52", \
                          ADDR szDisplayName,MB_OK
          Case 53
            fn MessageBox,hWin,"WM_COMMAND ID 53", \
                          ADDR szDisplayName,MB_OK
          Case 54
            fn MessageBox,hWin,"WM_COMMAND ID 54", \
                          ADDR szDisplayName,MB_OK
          Case 55
            fn MessageBox,hWin,"WM_COMMAND ID 55", \
                          ADDR szDisplayName,MB_OK
          Case 56
            fn MessageBox,hWin,"WM_COMMAND ID 56", \
                          ADDR szDisplayName,MB_OK
          Case 57
            fn MessageBox,hWin,"WM_COMMAND ID 57", \
                          ADDR szDisplayName,MB_OK
          Case 58
            fn MessageBox,hWin,"WM_COMMAND ID 58", \
                          ADDR szDisplayName,MB_OK

        ;======== menu commands ========

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900
            ShellAboutBox hWin,hIcon,\
              "About Prostart 3 Template#Windows Application",\
              "Prostart 3 Template",13,10,"Copyright  MASM32 1998-2003"

          case 3000
            invoke get_select_rect,hSelect,ADDR Rct

            mov eax, Rct.right
            sub eax, Rct.left
            mov wd, eax

            mov eax, Rct.bottom
            sub eax, Rct.top
            mov ht, eax

            .if wd > 5 || ht > 5
              fn PushButton,"Button",hSelect,Rct.left,Rct.top,wd,ht,500
            .endif

          ;====== end menu commands ======
      Endsw

      Case WM_CREATE
        invoke Do_ToolBar,hWin
      ; -----------------------
      ; create selection window
      ; -----------------------
        mov hSelect, rv(select_win,hWin,hInstance,0,0,100,100,3000)
        invoke SetClassLong,hSelect,GCL_HBRBACKGROUND,
                            rv(CreateSolidBrush,00FFAAAAh)      ; change background colour
        invoke SetClassLong,hSelect,GCL_HCURSOR,
                            rv(LoadCursor,NULL,IDC_CROSS)       ; change cursor

      Case WM_SYSCOLORCHANGE
        invoke Do_ToolBar,hWin

      Case WM_SIZE
        invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0

        invoke GetClientRect,hToolBar,ADDR Rct
        mov eax, Rct.bottom
        mov tbh, eax
        add tbh, 2

        invoke GetClientRect,hWin,ADDR Rct

        mov eax, tbh
        sub Rct.bottom, eax

        invoke MoveWindow,hSelect,0,tbh,Rct.right,Rct.bottom,TRUE

      Case WM_PAINT
        invoke Paint_Proc,hWin
        return 0

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; 

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    invoke BeginPaint,hWin,ADDR Ps
    mov hDC, eax

  ; ----------------------------------------

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; 

select_win proc hParent:DWORD,instance:DWORD,
                tx:DWORD,ty:DWORD,wd:DWORD,ht:DWORD,IDnum:DWORD

    LOCAL hWin  :DWORD
    LOCAL pbuf  :DWORD
    LOCAL buffer[64]:BYTE
    LOCAL wc    :WNDCLASSEX

    mov pbuf, ptr$(buffer)

    mov wc.cbSize,        sizeof WNDCLASSEX
    mov wc.style,         CS_BYTEALIGNCLIENT or \
                          CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,   OFFSET select_proc
    mov wc.cbClsExtra,    NULL
    mov wc.cbWndExtra,    36
    m2m wc.hInstance,     instance
    mov wc.hbrBackground, COLOR_WINDOW+1
    mov wc.lpszMenuName,  NULL
    mov wc.lpszClassName, cat$(pbuf,"sel_class_",str$(GetTickCount))   ; ensure unique class name
    mov wc.hIcon,         NULL
    mov wc.hCursor,       FUNC(LoadCursor,NULL,IDC_ARROW)
    mov wc.hIconSm,       NULL

    invoke RegisterClassEx, ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          wc.lpszClassName,
                          NULL,
                          WS_BORDER or WS_CHILD,
                          tx,ty,wd,ht,
                          hParent,NULL,
                          instance,NULL
    mov hWin, eax
  ; --------------------------------------------------
  ; write the return message ID number to extra memory
  ; --------------------------------------------------
    invoke SetWindowLong,hWin,24,IDnum

    invoke ShowWindow,hWin,SW_SHOW
    mov eax, hWin

    ret

select_win endp

; 

select_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hDC       :DWORD
    LOCAL rct       :RECT

    switch uMsg

      case WM_LBUTTONDOWN
        invoke SetFocus,hWin

        movsx eax, WORD PTR [ebp+20]
        mov rct.left, eax
        movsx eax, WORD PTR [ebp+22]
        mov rct.top, eax

      ; -------------------------------------------------------------
      ; this pair can be modified in the following message processing
      ; -------------------------------------------------------------
        invoke SetWindowLong,hWin,0,rct.left
        invoke SetWindowLong,hWin,4,rct.top

      ; -----------------------------------
      ; this pair are the reference for the
      ; original mouse down co-ordinates
      ; -----------------------------------
        invoke SetWindowLong,hWin,16,rct.left
        invoke SetWindowLong,hWin,20,rct.top

        m2m rct.right, rct.left
        m2m rct.bottom, rct.top

        add rct.right, 1
        add rct.bottom, 1

        invoke SetWindowLong,hWin,8, rct.right
        invoke SetWindowLong,hWin,12,rct.bottom

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR rct
        invoke ReleaseDC,hWin,hDC

    ; ====================================

      case WM_MOUSEMOVE
      .if wParam == MK_LBUTTON
        mov hDC, rv(GetDC,hWin)

        mov rct.left,   rv(GetWindowLong,hWin,0)
        mov rct.top,    rv(GetWindowLong,hWin,4)
        mov rct.right,  rv(GetWindowLong,hWin,8)
        mov rct.bottom, rv(GetWindowLong,hWin,12)

        invoke DrawFocusRect,hDC,ADDR rct

      ; -------------------------------------------------
      ; retrieve the reference pair of mouse co-ordinates
      ; -------------------------------------------------
        mov rct.left,   rv(GetWindowLong,hWin,16)
        mov rct.top,    rv(GetWindowLong,hWin,20)

      ; ----------------------------------
      ; get the current mouse co-ordinates
      ; ----------------------------------
        movsx eax, WORD PTR [ebp+20]
        mov rct.right, eax
        movsx eax, WORD PTR [ebp+22]
        mov rct.bottom, eax

        push ebx
        mov eax, rct.left
        mov ebx, rct.top
        mov ecx, rct.right
        mov edx, rct.bottom

        .if eax <= ecx && ebx <= edx
          mov rct.left, eax
          mov rct.top, ebx
          mov rct.right, ecx
          mov rct.bottom, edx
        .elseif eax >= ecx && ebx >= edx
          mov rct.left, ecx
          mov rct.top, edx
          mov rct.right, eax
          mov rct.bottom, ebx
        .elseif eax >= ecx && edx >= ebx
          mov rct.left, ecx
          mov rct.top, ebx
          mov rct.right, eax
          mov rct.bottom, edx
        .elseif eax <= ecx && edx <= ebx
          mov rct.left, eax
          mov rct.top, edx
          mov rct.right, ecx
          mov rct.bottom, ebx
        .endif

        pop ebx

        invoke DrawFocusRect,hDC,ADDR rct

        invoke SetWindowLong,hWin,0,rct.left
        invoke SetWindowLong,hWin,4,rct.top
        invoke SetWindowLong,hWin,8,rct.right
        invoke SetWindowLong,hWin,12,rct.bottom
        invoke ReleaseDC,hWin,hDC

      .endif

    ; ====================================

      case WM_LBUTTONUP
        mov hDC, rv(GetDC,hWin)
        mov rct.left,   rv(GetWindowLong,hWin,0)
        mov rct.top,    rv(GetWindowLong,hWin,4)
        mov rct.right,  rv(GetWindowLong,hWin,8)
        mov rct.bottom, rv(GetWindowLong,hWin,12)
        invoke DrawFocusRect,hDC,ADDR rct
        invoke ReleaseDC,hWin,hDC

      ; ---------------------------------------------------
      ; retrieve the ID number from extra memory and notify
      ; the parent window that the selection has been made.
      ; ---------------------------------------------------
        push esi
        mov esi, rv(GetWindowLong,hWin,24)
        invoke SendMessage,rv(GetParent,hWin),WM_COMMAND,esi,0
        pop esi

    endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

select_proc endp

; 

get_select_rect proc hWin:DWORD,lprect:DWORD

    push esi

    mov esi, lprect
    mov (RECT PTR [esi]).left,   rv(GetWindowLong,hWin,0)
    mov (RECT PTR [esi]).top,    rv(GetWindowLong,hWin,4)
    mov (RECT PTR [esi]).right,  rv(GetWindowLong,hWin,8)
    mov (RECT PTR [esi]).bottom, rv(GetWindowLong,hWin,12)

    pop esi

    ret

get_select_rect endp

; 

PushButton proc lpText:DWORD,hParent:DWORD,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

    LOCAL hButn :DWORD

    fn CreateWindowEx, \
            0,"BUTTON",lpText,WS_CHILD or WS_VISIBLE, \
            a,b,wd,ht,hParent,ID,hInstance,NULL
    mov hButn, eax
    mov lpButnProc, rv(SetWindowLong,hButn,GWL_WNDPROC,ButnProc)
    invoke SetFocus,hButn
    mov eax, hButn

    ret

PushButton endp

; 

ButnProc proc hCtl   :DWORD,
              uMsg   :DWORD,
              wParam :DWORD,
              lParam :DWORD

    LOCAL xPos :DWORD
    LOCAL yPos :DWORD
    LOCAL hParent :DWORD
    LOCAL rct  :RECT
    LOCAL pt1  :POINT
    LOCAL pt2  :POINT
    LOCAL pbuf :DWORD
    LOCAL buffer[64]:BYTE

  ; -----------------------------
  ; Process control messages here
  ; -----------------------------

    switch uMsg

      case WM_KEYDOWN
        invoke GetWindowRect,hCtl,ADDR rct
        mov hParent, rv(GetParent,hCtl)

        m2m pt1.x, rct.left
        m2m pt1.y, rct.top
        invoke ScreenToClient,hParent,ADDR pt1

        m2m pt2.x, rct.right
        m2m pt2.y, rct.bottom
        invoke ScreenToClient,hParent,ADDR pt2

        mov eax, pt2.x
        sub eax, pt1.x
        mov pt2.x, eax

        mov eax, pt2.y
        sub eax, pt1.y
        mov pt2.y, eax

        invoke GetKeyState,VK_SHIFT
        .if eax == 0FFFFFF81h || eax == 0FFFFFF80h
          jmp over
        .endif

        switch wParam           ; move position
          case VK_LEFT
            sub pt1.x, 1
          case VK_RIGHT
            add pt1.x, 1
          case VK_UP
            sub pt1.y, 1
          case VK_DOWN
            add pt1.y, 1
        endsw
        jmp past

      over:
        switch wParam           ; change size
          case VK_LEFT
            sub pt2.x, 1
          case VK_RIGHT
            add pt2.x, 1
          case VK_UP
            sub pt2.y, 1
          case VK_DOWN
            add pt2.y, 1
        endsw

      past:

        invoke MoveWindow,hCtl,pt1.x,pt1.y,pt2.x,pt2.y,TRUE

      case WM_KEYUP
        switch wParam
          case VK_DELETE
            invoke DestroyWindow,hCtl
        endsw

      case WM_LBUTTONDOWN
        .data?
          @_posx_@ dd ?
          @_posy_@ dd ?
          @_flag_@ dd ?
        .code

        movsx eax, word ptr [ebp+20]
        mov @_posx_@, eax
        movsx eax, word ptr [ebp+22]
        mov @_posy_@, eax

        mov @_flag_@, 1

        invoke SetFocus,hCtl
        invoke SetCapture,hCtl
        ret

      case WM_LBUTTONDBLCLK
        invoke SetFocus,hCtl
        ret

        ; -------------------------------------------------------------------------

      case WM_MOUSEMOVE

        .if @_flag_@ == 1

          movsx eax, word ptr [ebp+20]
          mov xPos, eax
          movsx eax, word ptr [ebp+22]
          mov yPos, eax

          invoke GetWindowRect,hCtl,ADDR rct
          mov hParent, rv(GetParent,hCtl)

          m2m pt1.x, xPos
          m2m pt1.y, yPos
          invoke ClientToScreen,hCtl,ADDR pt1
          invoke ScreenToClient,hParent,ADDR pt1
          m2m xPos, pt1.x
          m2m yPos, pt1.y

          mov eax, @_posx_@
          sub xPos, eax
          mov eax, @_posy_@
          sub yPos, eax

          m2m pt1.x, rct.left
          m2m pt1.y, rct.top
          invoke ScreenToClient,hParent,ADDR pt1

          m2m pt2.x, rct.right
          m2m pt2.y, rct.bottom
          invoke ScreenToClient,hParent,ADDR pt2

        ; --------------------------
        ; calculate width and height
        ; --------------------------
          mov eax, pt2.x
          sub eax, pt1.x
          mov pt2.x, eax

          mov eax, pt2.y
          sub eax, pt1.y
          mov pt2.y, eax

          invoke MoveWindow,hCtl,xPos,yPos,pt2.x,pt2.y,TRUE

        .endif

        ; -------------------------------------------------------------------------

      case WM_LBUTTONUP
        mov @_flag_@, 0
        invoke ReleaseCapture

    endsw

    invoke CallWindowProc,lpButnProc,hCtl,uMsg,wParam,lParam

    ret

ButnProc endp

; 



end start
